#include <system.h>
#include "Nokia3310.h"

//Target PIC16F688 configuration word
#pragma DATA _CONFIG, 0x3fd0	//OSC=LP,WDT=OFF,PUT=OFF,MCLR=Internal
//Set clock frequency
#pragma CLOCK_FREQ	32768


char Hour=0;
char Min=0;
char Sec=0;
int Temp=20;
char BuzzFlg=1;

void interrupt( void )
{	
	if(intcon & (1 <<T0IF)){
		//ϊ荞݂̏
		clear_bit(intcon,T0IF);
		//uU[ij̉j
		if(BuzzFlg){
			set_bit(portc,5);
			clear_bit(portc,5);
		}
		//Ԃ̌vZ
		Sec++;
		if(Sec>=60){
			Sec=0;
			Min++;
			if(Min>=60){
				Min=0;
				Hour++;
				if(Hour>=24)
					Hour=0;
			}
		}
	}
}

void IoInit()
{
	//Port Setting
	osccon = 0x00;
	trisa = 0x01;
	trisb = 0x00;
	trisc = 0x0f;
	porta=0x00;
	portb=0x00;
	portc=0x00;
	ansel=1;	//AD0 Enable
	anselh=0;
	adcon1=0x70;	//ADC using internal clock
	tmr0=0;
	option_reg=0x84;	//Timer0 pre-Scaler=1/32
}

int GetTemp()
{
	int temp;
	//x(749-x)/9
	//start A/D
	porta.1=1;			//T[~X^ɓd͋
	adcon0=0xc3;		//f[^͉E,VREF=RA1
	while(adcon0 & 2);	//wait done
	porta.1=0;			
	temp=((adresh<<8)+adresl) & 0x3ff;
	temp=(740-temp)/9;
	return temp;
}

void main( void )
{
	char sw,osw;
	char hour,min,sec;
	int temp;
	
	hour=min=sec=0;
	temp=20;
	osw=0x0f;
	IoInit();
	LcdInit();
	
	//default Display
	LcdXy(3,1);
	LcdPutnum(0);
	LcdColon();
	LcdPutnum(0);
	LcdColon();
	LcdPutnum(0);

	LcdXy(1,4);
	LcdBuzz(1);
	LcdXy(6,4);
	LcdTemp();
	LcdXy(11,4);
	LcdPutnum(20);
	
	set_bit( intcon, T0IE );
	set_bit( intcon, GIE );

	while( 1 ){
		//Ԃ̕\
		if(Hour!=hour){
			LcdXy(3,1);
			LcdPutnum(Hour);
			hour=Hour;
		}
		if(Min!=min){
			LcdXy(6,1);
			LcdPutnum(Min);
			min=Min;
		}
		if(Sec!=sec){
			LcdXy(9,1);
			LcdPutnum(Sec);
			sec=Sec;
			//x̑
			Temp=GetTemp();
		}
		if(Temp!=temp){
			LcdXy(11,4);
			LcdPutnum(Temp);
			temp=Temp;
		}
		//XCb`̑
		sw=portc&0x0f;
		if(osw==0x0f){
			//XCb`ꂽƂ̂ݑ
			if(!(sw.0)){
				//bZbg
				Sec=0;
			}else if(!(sw.1)){
				//̃CNg
				if(Min>=59)
					Min=0;
				else
					Min++;
			}else if(!(sw.2)){
				//Ԃ̃CNg
				if(Hour>=23)
					Hour=0;
				else
					Hour++;
			}else if(!(sw.3)){
				if(BuzzFlg){
					//~߂
					BuzzFlg=0;
				}else{
					//o
					BuzzFlg=1;
				}
				LcdXy(1,4);
				LcdBuzz(BuzzFlg);
				
			}
		}
		osw=sw;
	}
}
